Index: trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/DeterministicFiniteAutomaton.java
===================================================================
--- trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/DeterministicFiniteAutomaton.java	(revision 92)
+++ trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/DeterministicFiniteAutomaton.java	(revision 93)
@@ -19,5 +19,5 @@
 
 	@Override
-	public double getProbability(List<Event<?>> context, Event<?> symbol) {
+	public double getProbability(List<? extends Event<?>> context, Event<?> symbol) {
 		double result = 0.0d;
 		
Index: trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/HighOrderMarkovModel.java
===================================================================
--- trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/HighOrderMarkovModel.java	(revision 92)
+++ trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/HighOrderMarkovModel.java	(revision 93)
@@ -19,5 +19,5 @@
 	
 	@Override
-	public double getProbability(List<Event<?>> context, Event<?> symbol) {
+	public double getProbability(List<? extends Event<?>> context, Event<?> symbol) {
 		double result = 0.0d;
 		
Index: trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/IStochasticProcess.java
===================================================================
--- trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/IStochasticProcess.java	(revision 92)
+++ trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/IStochasticProcess.java	(revision 93)
@@ -9,7 +9,9 @@
 public interface IStochasticProcess extends Serializable {
 	
-	double getProbability(List<Event<?>> context, Event<?> symbol);
+	double getProbability(List<? extends Event<?>> context, Event<?> symbol);
 
 	public List<? extends Event<?>> randomSequence();
+	
+	public Set<List<? extends Event<?>>> generateSequences(int length);
 	
 	public int getNumStates();
@@ -17,5 +19,5 @@
 	public String[] getStateStrings();
 	
-	public Set<Event<?>> getEvents();
+	public Set<? extends Event<?>> getEvents();
 
 }
Index: trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/PredictionByPartialMatch.java
===================================================================
--- trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/PredictionByPartialMatch.java	(revision 92)
+++ trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/PredictionByPartialMatch.java	(revision 93)
@@ -34,5 +34,5 @@
 	
 	@Override
-	public double getProbability(List<Event<?>> context, Event<?> symbol) {
+	public double getProbability(List<? extends Event<?>> context, Event<?> symbol) {
 		double result = 0.0d;
 		double resultCurrentContex = 0.0d;
Index: trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/TrieBasedModel.java
===================================================================
--- trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/TrieBasedModel.java	(revision 92)
+++ trunk/EventBenchCore/src/de/ugoe/cs/eventbench/models/TrieBasedModel.java	(revision 93)
@@ -1,4 +1,7 @@
 package de.ugoe.cs.eventbench.models;
 
+import java.security.InvalidParameterException;
+import java.util.ArrayList;
+import java.util.LinkedHashSet;
 import java.util.LinkedList;
 import java.util.List;
@@ -104,6 +107,34 @@
 	}
 	
-	public Set<Event<?>> getEvents() {
+	public Set<? extends Event<?>> getEvents() {
 		return trie.getKnownSymbols();
+	}
+	
+	public Set<List<? extends Event<?>>> generateSequences(int length) {
+		Set<List<? extends Event<?>>> sequenceSet = new LinkedHashSet<List<? extends Event<?>>>();;
+		if( length<1 ) {
+			throw new InvalidParameterException("Length of generated subsequences must be at least 1.");
+		}
+		if( length==1 ) {
+			for( Event<?> event : getEvents() ) {
+				List<Event<?>> subSeq = new LinkedList<Event<?>>();
+				subSeq.add(event);
+				sequenceSet.add(subSeq);
+			}
+			return sequenceSet;
+		}
+		Set<? extends Event<?>> events = getEvents();
+		Set<List<? extends Event<?>>> seqsShorter = generateSequences(length-1);
+		for( Event<?> event : events ) {
+			for( List<? extends Event<?>> seqShorter : seqsShorter ) {
+				Event<?> lastEvent = event;
+				if( getProbability(seqShorter, lastEvent)>0.0 ) {
+					List<Event<?>> subSeq = new ArrayList<Event<?>>(seqShorter);
+					subSeq.add(lastEvent);
+					sequenceSet.add(subSeq);
+				}
+			}
+		}
+		return sequenceSet;
 	}
 
